from flask import Blueprint, request
from markupsafe import escape
from web_utils.get_arg import get_arg

from data.document import Document

bp = Blueprint('document', __name__, url_prefix='/api/doc')

@bp.route('/build')
def build():
	doc_name = get_arg('doc')
	branch = get_arg('branch', 'master')
	
	doc = Document(doc_name, branch)
	output = doc.build()
	
	return output.replace('\n', '<br/>')

