import os
from subprocess import Popen, PIPE, STDOUT

document_root = None

class Document:
	def __init__(self, doc_name, branch = 'master'):
		self.doc_name = doc_name
		self.branch = branch
		
		#print(get_document_root())
		#print(doc_name)
		#print(branch)
		
		doc_path = os.path.realpath(get_document_root()+'/'+doc_name+'/'+branch)
		if not doc_path.startswith(get_document_root()):
			raise Exception("Invalid document path for '"+doc_name+"'@'"+branch)
		
		self.doc_path = doc_path
	
	def build(self):
		#venv_path = os.getenv('VIRTUAL_ENV')
		cmd = "sphinx-build -M html \""+self.doc_path + "/source\" \""+self.doc_path+"/build\""
		p = Popen(cmd, stdout = PIPE, stderr = STDOUT, shell = True)
		outputStr = ""
		for line in p.stdout:
			outputStr += line.decode()
		
		p.wait()
		
		if p.returncode != 0:
			raise Exception("Build failed ("+str(p.returncode)+")\n"+outputStr)
			
		return outputStr

def set_document_root(dir):
	global document_root
	document_root = dir
	
def get_document_root():
	global document_root
	return document_root

